## dde-clipboard 5.3.16

=== debian/changelog ===
dde-clipboard (5.3.16-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Wed, 14 Apr 2021 17:44:18 +0800

dde-clipboard (1.0.0) unstable; urgency=low

  * Autobuild Tag 1.0.0

 -- TagBuilder <tagbuilder@deepin.com>  Fri, 12 Aug 2016 18:43:22 +0000

## dde-clipboard 5.4.20

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(BIN_NAME dde-clipboard)

project(${BIN_NAME})

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# Find the library
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(KF5Wayland REQUIRED)
find_package(Qt5 COMPONENTS Core Widgets DBus Test REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(GIO REQUIRED gio-qt)

function(generation_dbus_adaptor xml class_name class_file option)
    execute_process(COMMAND qdbusxml2cpp ${option} -a ${class_file} -c ${class_name} ${xml}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endfunction(generation_dbus_adaptor)

include_directories(
    dde-clipboard
    dde-clipboard/dbus
    dde-clipboard/displaymanager
    dde-clipboardloader
)

#----------------------------dde-clipboard------------------------------
generation_dbus_adaptor(
    ${CMAKE_SOURCE_DIR}/dde-clipboard/com.deepin.dde.Clipboard.xml
    ClipboardAdaptor
    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor
    -N
)

set(Clipboard_DBUS_SCRS
    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor.h
    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor.cpp
)

file(GLOB_RECURSE Clipboard_SCRS
    "dde-clipboard/*.h"
    "dde-clipboard/*.cpp"
)
list(REMOVE_ITEM Clipboard_SCRS "${CMAKE_SOURCE_DIR}/dde-clipboard/main.cpp")

add_executable(${BIN_NAME}
    ${Clipboard_SCRS}
    ${Clipboard_DBUS_SCRS}
    dde-clipboard/main.cpp
)
target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    Qt5::Core
    Qt5::Widgets
    Qt5::DBus
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${GIO_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    Qt5::Core
    Qt5::Widgets
    Qt5::DBus
)

## qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION share/${BIN_NAME}/translations)

## desktop file
file(GLOB DESKTOP_FILE "misc/dde-clipboard.desktop")
install(FILES ${DESKTOP_FILE} DESTINATION share/applications)

## autostart
set(AUTOSTART_FILE ${DESKTOP_FILE})
install(FILES ${AUTOSTART_FILE} DESTINATION /etc/xdg/autostart)

## dbus service
file(GLOB SERVICE_FILE "misc/com.deepin.dde.Clipboard.service")
install(FILES ${SERVICE_FILE} DESTINATION share/dbus-1/services)

## bin
install(TARGETS ${BIN_NAME} DESTINATION bin)

#----------------------------dde-clipboard-daemon------------------------------
set(BIN_NAME dde-clipboard-daemon)

file(GLOB_RECURSE dde-clipboard-daemon_SCRS
    "dde-clipboard-daemon/main.cpp"
    "dde-clipboard-daemon/dbus_manager.cpp"
    "dde-clipboard-daemon/dbus_manager.h"
)

add_executable(${BIN_NAME}
    ${dde-clipboard-daemon_SCRS}
)

target_include_directories(${BIN_NAME} PUBLIC
  ${Qt5Widget_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${DtkCore_INCLUDE_DIRS}
  )

target_link_libraries(${BIN_NAME} PRIVATE
  ${Qt5DBus_LIBRARIES}
  ${Qt5Core_LIBRARIES}
  ${Qt5Widgets_LIBRARIES}
  ${DtkCore_LIBRARIES}
)

install(TARGETS ${BIN_NAME} DESTINATION bin)
install(FILES misc/dde-clipboard-daemon.service
    DESTINATION /lib/systemd/user
)
install(FILES misc/dde-clipboard-daemon.desktop
    DESTINATION /usr/share/applications/
)
install(FILES misc/dde-clipboard-daemon.desktop
    DESTINATION /etc/xdg/autostart/
)

#----------------------------dde-clipboard-loader------------------------------
set(PLUGIN_NAME "dde-clipboard-loader")

file(GLOB_RECURSE dde-clipboard-loader_SCRS
    "dde-clipboard-daemon/plugin/dde-clipboard-loader/*.h"
    "dde-clipboard-daemon/plugin/dde-clipboard-loader/*.cpp"
    "dde-clipboard-daemon/plugin/dde-clipboard-loader/src/*.h"
    "dde-clipboard-daemon/plugin/dde-clipboard-loader/src/*.cpp"
)

add_definitions("${QT_DEFINITIONS} -DCLIPBOARD_LIBRARY")

add_library(${PLUGIN_NAME} SHARED
    ${dde-clipboard-loader_SCRS}
)

set_target_properties(${PLUGIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY
    plugins/
)

target_include_directories(${PLUGIN_NAME} PUBLIC
  ${Qt5Widget_INCLUDE_DIRS}
  ${Qt5DBus_INCLUDE_DIRS}
  KF5::WaylandServer
  "dde-clipboard-daemon/plugin/dde-clipboard-loader/src"
  )

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${Qt5Widgets_LIBRARIES}
  ${Qt5DBus_LIBRARIES}
  KF5::WaylandClient
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-clipboard/)

#----------------------------dde-clipboard-manager------------------------------
set(PLUGIN_NAME "dde-clipboard-manager")

file(GLOB_RECURSE dde-clipboard-manager_SRCS
    "dde-clipboard-daemon/plugin/dde-clipboard-manager/*.h"
    "dde-clipboard-daemon/plugin/dde-clipboard-manager/*.cpp"
    "dde-clipboard-daemon/plugin/dde-clipboard-manager/src/*.h"
    "dde-clipboard-daemon/plugin/dde-clipboard-manager/src/*.cpp"
)

add_definitions("${QT_DEFINITIONS} -DCLIPBOARD_LIBRARY")

add_library(${PLUGIN_NAME} SHARED ${dde-clipboard-manager_SRCS})

set_target_properties(${PLUGIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY
    plugins/
)

target_include_directories(${PLUGIN_NAME} PUBLIC
  ${Qt5Widget_INCLUDE_DIRS}
  ${Qt5DBus_INCLUDE_DIRS}
  KF5::WaylandServer
  "dde-clipboard-daemon/plugin/dde-clipboard-manager/src"
  )

target_link_libraries(${PLUGIN_NAME} PRIVATE
  ${Qt5Widgets_LIBRARIES}
  ${Qt5DBus_LIBRARIES}
  KF5::WaylandClient
)

install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-clipboard/)

#----------------------------ut-dde-clipboard------------------------------
set(UT_BIN_NAME ut-dde-clipboard)

file(GLOB_RECURSE ut_Clipboard_SCRS
    "tests/dde-clipboard/*.h"
    "tests/dde-clipboard/*.cpp"
    "tests/dde-clipboard/*.qrc"
)

add_executable(${UT_BIN_NAME}
    ${Clipboard_SCRS}
    ${Clipboard_DBUS_SCRS}
    ${ut_Clipboard_SCRS}
)
# 用于测试覆盖率的编译条件
target_compile_options(${UT_BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)

target_include_directories(${UT_BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    Qt5::Core
    Qt5::Widgets
    Qt5::DBus
    Qt5::Test
)

target_link_libraries(${UT_BIN_NAME} PRIVATE
    ${DtkWidget_LIBRARIES}
    ${GIO_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    Qt5::Core
    Qt5::Widgets
    Qt5::DBus
    Qt5::Test
    -lpthread
    -lgcov
    -lgtest
)

=== debian/changelog ===
dde-clipboard (1:5.4.20-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Sat, 27 Aug 2022 13:28:19 +0800

## dde-clipboard 5.4.24

=== debian/changelog ===
dde-clipboard (1:5.4.24-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Thu, 13 Oct 2022 19:40:14 +0800

## dde-clipboard 5.4.26.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,8 +17,8 @@
 set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
 
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
 endif()
 
 if (DEFINED ENABLE_MIEEE)
@@ -46,6 +46,20 @@
 
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 pkg_check_modules(GIO REQUIRED gio-qt)
+
+try_compile(USE_DEEPIN_KF5_WAYLAND
+              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
+            SOURCES
+              ${CMAKE_CURRENT_SOURCE_DIR}/tests/kf5_wayland_test.cc
+            LINK_LIBRARIES
+              KF5::WaylandClient
+)
+
+message(STATUS "USE_DEEPIN_KF5_WAYLAND ${USE_DEEPIN_KF5_WAYLAND}")
+
+if(USE_DEEPIN_KF5_WAYLAND)
+  add_definitions(-DUSE_DEEPIN_KF5_WAYLAND)
+endif()
 
 function(generation_dbus_adaptor xml class_name class_file option)
     execute_process(COMMAND qdbusxml2cpp ${option} -a ${class_file} -c ${class_name} ${xml}
@@ -125,9 +139,8 @@
 set(BIN_NAME dde-clipboard-daemon)
 
 file(GLOB_RECURSE dde-clipboard-daemon_SCRS
-    "dde-clipboard-daemon/main.cpp"
-    "dde-clipboard-daemon/dbus_manager.cpp"
-    "dde-clipboard-daemon/dbus_manager.h"
+   "dde-clipboard-daemon/*.h"
+   "dde-clipboard-daemon/*.cpp"
 )
 
 add_executable(${BIN_NAME}
@@ -138,13 +151,15 @@
   ${Qt5Widget_INCLUDE_DIRS}
   ${Qt5Core_INCLUDE_DIRS}
   ${DtkCore_INCLUDE_DIRS}
-  )
+  KF5::WaylandClient
+)
 
 target_link_libraries(${BIN_NAME} PRIVATE
   ${Qt5DBus_LIBRARIES}
   ${Qt5Core_LIBRARIES}
   ${Qt5Widgets_LIBRARIES}
   ${DtkCore_LIBRARIES}
+  KF5::WaylandClient
 )
 
 install(TARGETS ${BIN_NAME} DESTINATION bin)
@@ -157,76 +172,6 @@
 install(FILES misc/dde-clipboard-daemon.desktop
     DESTINATION /etc/xdg/autostart/
 )
-
-#----------------------------dde-clipboard-loader------------------------------
-set(PLUGIN_NAME "dde-clipboard-loader")
-
-file(GLOB_RECURSE dde-clipboard-loader_SCRS
-    "dde-clipboard-daemon/plugin/dde-clipboard-loader/*.h"
-    "dde-clipboard-daemon/plugin/dde-clipboard-loader/*.cpp"
-    "dde-clipboard-daemon/plugin/dde-clipboard-loader/src/*.h"
-    "dde-clipboard-daemon/plugin/dde-clipboard-loader/src/*.cpp"
-)
-
-add_definitions("${QT_DEFINITIONS} -DCLIPBOARD_LIBRARY")
-
-add_library(${PLUGIN_NAME} SHARED
-    ${dde-clipboard-loader_SCRS}
-)
-
-set_target_properties(${PLUGIN_NAME} PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY
-    plugins/
-)
-
-target_include_directories(${PLUGIN_NAME} PUBLIC
-  ${Qt5Widget_INCLUDE_DIRS}
-  ${Qt5DBus_INCLUDE_DIRS}
-  KF5::WaylandServer
-  "dde-clipboard-daemon/plugin/dde-clipboard-loader/src"
-  )
-
-target_link_libraries(${PLUGIN_NAME} PRIVATE
-  ${Qt5Widgets_LIBRARIES}
-  ${Qt5DBus_LIBRARIES}
-  KF5::WaylandClient
-)
-
-install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-clipboard/)
-
-#----------------------------dde-clipboard-manager------------------------------
-set(PLUGIN_NAME "dde-clipboard-manager")
-
-file(GLOB_RECURSE dde-clipboard-manager_SRCS
-    "dde-clipboard-daemon/plugin/dde-clipboard-manager/*.h"
-    "dde-clipboard-daemon/plugin/dde-clipboard-manager/*.cpp"
-    "dde-clipboard-daemon/plugin/dde-clipboard-manager/src/*.h"
-    "dde-clipboard-daemon/plugin/dde-clipboard-manager/src/*.cpp"
-)
-
-add_definitions("${QT_DEFINITIONS} -DCLIPBOARD_LIBRARY")
-
-add_library(${PLUGIN_NAME} SHARED ${dde-clipboard-manager_SRCS})
-
-set_target_properties(${PLUGIN_NAME} PROPERTIES
-    LIBRARY_OUTPUT_DIRECTORY
-    plugins/
-)
-
-target_include_directories(${PLUGIN_NAME} PUBLIC
-  ${Qt5Widget_INCLUDE_DIRS}
-  ${Qt5DBus_INCLUDE_DIRS}
-  KF5::WaylandServer
-  "dde-clipboard-daemon/plugin/dde-clipboard-manager/src"
-  )
-
-target_link_libraries(${PLUGIN_NAME} PRIVATE
-  ${Qt5Widgets_LIBRARIES}
-  ${Qt5DBus_LIBRARIES}
-  KF5::WaylandClient
-)
-
-install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-clipboard/)
 
 #----------------------------ut-dde-clipboard------------------------------
 set(UT_BIN_NAME ut-dde-clipboard)

=== debian/changelog ===
dde-clipboard (1:5.4.26.1-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Tue, 11 Apr 2023 11:09:42 +0800

## dde-clipboard 5.15.0102.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,13 +12,11 @@
 set(CMAKE_CXX_FLAGS "-g -Wall")
 
 # 增加安全编译参数
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all")
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
-set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie")
+ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
 
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
 endif()
 
 if (DEFINED ENABLE_MIEEE)
@@ -46,20 +44,6 @@
 
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 pkg_check_modules(GIO REQUIRED gio-qt)
-
-try_compile(USE_DEEPIN_KF5_WAYLAND
-              ${CMAKE_CURRENT_BINARY_DIR}/try_compile
-            SOURCES
-              ${CMAKE_CURRENT_SOURCE_DIR}/tests/kf5_wayland_test.cc
-            LINK_LIBRARIES
-              KF5::WaylandClient
-)
-
-message(STATUS "USE_DEEPIN_KF5_WAYLAND ${USE_DEEPIN_KF5_WAYLAND}")
-
-if(USE_DEEPIN_KF5_WAYLAND)
-  add_definitions(-DUSE_DEEPIN_KF5_WAYLAND)
-endif()
 
 function(generation_dbus_adaptor xml class_name class_file option)
     execute_process(COMMAND qdbusxml2cpp ${option} -a ${class_file} -c ${class_name} ${xml}
@@ -121,7 +105,7 @@
 install(FILES ${QM_FILES} DESTINATION share/${BIN_NAME}/translations)
 
 ## desktop file
-file(GLOB DESKTOP_FILE "misc/dde-clipboard.desktop")
+file(GLOB DESKTOP_FILE "dde-clipboard/dde-clipboard.desktop")
 install(FILES ${DESKTOP_FILE} DESTINATION share/applications)
 
 ## autostart
@@ -129,49 +113,45 @@
 install(FILES ${AUTOSTART_FILE} DESTINATION /etc/xdg/autostart)
 
 ## dbus service
-file(GLOB SERVICE_FILE "misc/com.deepin.dde.Clipboard.service")
+file(GLOB SERVICE_FILE "dde-clipboard/com.deepin.dde.Clipboard.service")
 install(FILES ${SERVICE_FILE} DESTINATION share/dbus-1/services)
 
 ## bin
 install(TARGETS ${BIN_NAME} DESTINATION bin)
 
-#----------------------------dde-clipboard-daemon------------------------------
-set(BIN_NAME dde-clipboard-daemon)
-
-file(GLOB_RECURSE dde-clipboard-daemon_SCRS
-   "dde-clipboard-daemon/*.h"
-   "dde-clipboard-daemon/*.cpp"
-)
-
-add_executable(${BIN_NAME}
-    ${dde-clipboard-daemon_SCRS}
-)
-
-target_include_directories(${BIN_NAME} PUBLIC
-  ${Qt5Widget_INCLUDE_DIRS}
-  ${Qt5Core_INCLUDE_DIRS}
-  ${DtkCore_INCLUDE_DIRS}
-  KF5::WaylandClient
-)
-
-target_link_libraries(${BIN_NAME} PRIVATE
-  ${Qt5DBus_LIBRARIES}
-  ${Qt5Core_LIBRARIES}
-  ${Qt5Widgets_LIBRARIES}
-  ${DtkCore_LIBRARIES}
-  KF5::WaylandClient
-)
-
-install(TARGETS ${BIN_NAME} DESTINATION bin)
-install(FILES misc/dde-clipboard-daemon.service
-    DESTINATION /lib/systemd/user
-)
-install(FILES misc/dde-clipboard-daemon.desktop
-    DESTINATION /usr/share/applications/
-)
-install(FILES misc/dde-clipboard-daemon.desktop
-    DESTINATION /etc/xdg/autostart/
-)
+#----------------------------dde-clipboardloader------------------------------
+set(LOADER_NAME dde-clipboardloader)
+
+file(GLOB_RECURSE ClipboardLoader_SCRS
+    "dde-clipboardloader/*.h"
+    "dde-clipboardloader/*.cpp"
+)
+list(REMOVE_ITEM ClipboardLoader_SCRS "${CMAKE_SOURCE_DIR}/dde-clipboardloader/main.cpp")
+
+add_executable(${LOADER_NAME}
+    ${ClipboardLoader_SCRS}
+    dde-clipboardloader/main.cpp
+    dde-clipboard/constants.h
+    dde-clipboard/dbus/iteminfo.h
+)
+target_include_directories(${LOADER_NAME} PUBLIC
+    ${DtkWidget_INCLUDE_DIRS}
+    KF5::WaylandClient
+    Qt5::Core
+    Qt5::Widgets
+    Qt5::DBus
+)
+
+target_link_libraries(${LOADER_NAME} PRIVATE
+    ${DtkWidget_LIBRARIES}
+    KF5::WaylandClient
+    Qt5::Core
+    Qt5::Widgets
+    Qt5::DBus
+)
+
+## bin
+install(TARGETS ${LOADER_NAME} DESTINATION bin)
 
 #----------------------------ut-dde-clipboard------------------------------
 set(UT_BIN_NAME ut-dde-clipboard)
@@ -213,3 +193,41 @@
     -lgcov
     -lgtest
 )
+
+#--------------------------ut-dde-clipboardloader----------------------------
+set(UT_LOADER_NAME ut-dde-clipboardloader)
+
+file(GLOB_RECURSE ut_Clipboardloader_SCRS
+    "tests/dde-clipboardloader/*.h"
+    "tests/dde-clipboardloader/*.cpp"
+)
+
+add_executable(${UT_LOADER_NAME}
+    ${ClipboardLoader_SCRS}
+    ${ut_Clipboardloader_SCRS}
+    dde-clipboard/constants.h
+    dde-clipboard/dbus/iteminfo.h
+)
+# 用于测试覆盖率的编译条件
+target_compile_options(${UT_BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
+
+target_include_directories(${UT_LOADER_NAME} PUBLIC
+    ${DtkWidget_INCLUDE_DIRS}
+    KF5::WaylandClient
+    Qt5::Core
+    Qt5::Widgets
+    Qt5::DBus
+    Qt5::Test
+)
+
+target_link_libraries(${UT_LOADER_NAME} PRIVATE
+    ${DtkWidget_LIBRARIES}
+    KF5::WaylandClient
+    Qt5::Core
+    Qt5::Widgets
+    Qt5::DBus
+    Qt5::Test
+    -lpthread
+    -lgcov
+    -lgtest
+)

=== debian/changelog ===
dde-clipboard (5.15.0102.7-1) unstable; urgency=medium

  * Non-maintainer upload.

 -- LiChengGang <lichenggang@uniontech.com>  Thu, 24 Feb 2022 15:29:33 +0800

dde-clipboard (5.4.7-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Mon, 21 Feb 2022 11:25:29 +0800

=== debian/control ===
Source: dde-clipboard
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends: debhelper (>= 8.0.0),
 pkg-config,
 cmake,
 libdtkwidget-dev,
 qttools5-dev-tools,
 libdtkcore5-bin,
 qtbase5-private-dev,
 libgio-qt-dev,
 libdframeworkdbus-dev,
 libgtest-dev,
 libkf5wayland-dev
Standards-Version: 3.9.5
Homepage: https://github.com/linuxdeepin/dde-clipboard

Package: dde-clipboard
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${dist:Depends},
 dde-daemon (>=5.12.0.31),
 startdde (>=5.6.0.34),
 dde-api (>=2.92.1),
 libdframeworkdbus2 (>=5.3.0.24),
 libkf5waylandclient5 (>=4:5.57.0.9)
Recommends: netselect, deepin-ab-recovery
Suggests: redshift
Description: deepin desktop-environment - clipboard module
 Clipboard module of deepin desktop-environment

## dde-clipboard 6.0.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(BIN_NAME dde-clipboard)

project(${BIN_NAME})

#set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O0")
endif()

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

include(GNUInstallDirs)

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Dtk COMPONENTS Widget Core REQUIRED)
find_package(Qt5 COMPONENTS Core Gui Widgets DBus Test Concurrent REQUIRED)

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
find_package(DWayland REQUIRED)

pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-qt)

if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

find_package(DtkTools REQUIRED)
function(generation_dbus_adaptor xml class_name class_file option)
    execute_process(COMMAND qdbusxml2cpp ${option} -a ${class_file} -c ${class_name} ${xml}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endfunction(generation_dbus_adaptor)

set(DBUS_INTERFACE ${PROJECT_SOURCE_DIR}/dbus/interface)
function(generation_dbus_interface xml class_name class_file)
    execute_process(COMMAND ${DTK_XML2CPP} -c ${class_name} -p ${class_file} ${xml}
        WORKING_DIRECTORY ${DBUS_INTERFACE})
endfunction(generation_dbus_interface)

include_directories(
    dde-clipboard
    dde-clipboard/dbus
    dde-clipboard/displaymanager
    dde-clipboardloader
)

#----------------------------dde-clipboard------------------------------
generation_dbus_adaptor(
    ${CMAKE_SOURCE_DIR}/dde-clipboard/org.deepin.dde.Clipboard1.xml
    ClipboardAdaptor
    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor
    -N
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.Display1.Monitor.xml
    Monitor
    ${DBUS_INTERFACE}/monitor_interface
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.Display1.xml
    Display1
    ${DBUS_INTERFACE}/display_interface
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.daemon.Dock1.xml
    Dock1
    ${DBUS_INTERFACE}/dock_interface
)

include_directories(
    ${PROJECT_SOURCE_DIR}/dbus/interface
    ${PROJECT_SOURCE_DIR}/dbus/types
    ${PROJECT_SOURCE_DIR}/dbus
)

aux_source_directory(dbus/types DBUS_TYPES)
aux_source_directory(dbus/interface DBUS_INTERFACES)

set(Clipboard_DBUS_SCRS
    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor.h
    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor.cpp
)

file(GLOB_RECURSE Clipboard_SCRS
    "dde-clipboard/*.h"
    "dde-clipboard/*.cpp"
)
list(REMOVE_ITEM Clipboard_SCRS "${CMAKE_SOURCE_DIR}/dde-clipboard/main.cpp")

add_executable(${BIN_NAME}
    ${Clipboard_SCRS}
    ${Clipboard_DBUS_SCRS}
    dde-clipboard/main.cpp
    ${DBUS_INTERFACES}
    ${DBUS_TYPES}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Dtk::Widget
    Dtk::Core
    PkgConfig::GIO
    Qt5::Core
    Qt5::Widgets
    Qt5::GuiPrivate
    Qt5::Gui
    Qt5::DBus
)

macro(install_symlink filepath wantsdir)
    file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/link/${wantsdir}/)
    execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${SYSTEMD_USER_UNIT_DIR}/${filepath} ${PROJECT_BINARY_DIR}/link/${wantsdir}/${filepath})
    install(FILES ${PROJECT_BINARY_DIR}/link/${wantsdir}/${filepath} DESTINATION ${SYSTEMD_USER_UNIT_DIR}/${wantsdir}/)
endmacro(install_symlink)

## qm files
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${BIN_NAME}/translations)

configure_file(
    misc/dde-clipboard.service.in
    dde-clipboard.service
    @ONLY
)

configure_file(
    misc/org.deepin.dde.Clipboard1.service.in
    org.deepin.dde.Clipboard1.service
    @ONLY
)

## dbus service
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.Clipboard1.service DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-clipboard.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})

install_symlink(dde-clipboard.service dde-session-initialized.target.wants)

## bin
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

#----------------------------dde-clipboard-daemon------------------------------
set(BIN_NAME dde-clipboard-daemon)

file(GLOB_RECURSE dde-clipboard-daemon_SCRS
        "dde-clipboard-daemon/*.h"
        "dde-clipboard-daemon/*.cpp"
)

add_executable(${BIN_NAME}
    ${dde-clipboard-daemon_SCRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Gui
  Qt5::DBus
  Qt5::Widgets
  Dtk::Core
  Qt5::Concurrent
  DWaylandClient
)

install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

configure_file(
    misc/org.deepin.dde.ClipboardLoader1.service.in
    org.deepin.dde.ClipboardLoader1.service
    @ONLY
)

configure_file(
    misc/org.deepin.dde.daemon.Clipboard1.service.in
    org.deepin.dde.daemon.Clipboard1.service
    @ONLY
)
configure_file(
    misc/dde-clipboard-daemon.service.in
    dde-clipboard-daemon.service
    @ONLY
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ClipboardLoader1.service
    DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.daemon.Clipboard1.service
    DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-clipboard-daemon.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})

#----------------------------ut-dde-clipboard------------------------------
set(UT_BIN_NAME ut-dde-clipboard)

file(GLOB_RECURSE ut_Clipboard_SCRS
    "tests/dde-clipboard/*.h"
    "tests/dde-clipboard/*.cpp"
    "tests/dde-clipboard/*.qrc"
)

add_executable(${UT_BIN_NAME}
    ${Clipboard_SCRS}
    ${Clipboard_DBUS_SCRS}
    ${ut_Clipboard_SCRS}
    ${DBUS_INTERFACES}
    ${DBUS_TYPES}
)
# 用于测试覆盖率的编译条件
target_compile_options(${UT_BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)

target_link_libraries(${UT_BIN_NAME} PRIVATE
    Dtk::Widget
    PkgConfig::GIO
    Qt5::Core
    Qt5::Widgets
    Qt5::DBus
    Qt5::Test
    Qt5::GuiPrivate
    -lpthread
    -lgcov
    -lgtest
)

=== debian/changelog ===
dde-clipboard (1:6.0.11) unstable; urgency=medium

  * feat: add dbus window visible property and changed signal
  * fix: border color issue

 -- Zhang Kun <zhangkun2@uniontech.com>  Fri, 12 Jul 2024 17:57:12 +0800

dde-clipboard (1:6.0.9) unstable; urgency=medium

  * release 1:6.0.9
  * fix #8415

 -- Mike Chen <chenke@deepin.org>  Wed, 08 May 2024 14:45:01 +0800

dde-clipboard (1:6.0.8) unstable; urgency=medium

  * fix: Dock cannot hide clipboard in non special effects mode(issue: https://github.com/linuxdeepin/developer-center/issues/8309)

 -- Zhang kun <zhangkun2@uniontech.com>  Mon, 29 Apr 2024 15:49:23 +0800

dde-clipboard (1:6.0.7) unstable; urgency=medium

  * fix: when line is min than 4, it elided

 -- chenhongtao <chenhongtao@deepin.org>  Wed, 06 Sep 2023 15:00:50 +0800

dde-clipboard (1:6.0.6) unstable; urgency=medium

  * chore: move elideText logic to itemdata
  * chore: add a commandline option

 -- chenhongtao <chenhongtao@deepin.org>  Thu, 31 Aug 2023 11:43:05 +0800

dde-clipboard (1:6.0.5) unstable; urgency=medium

  * fix cannot used on wayland
  * fix sytemd file, and make it starts after dde-session
  * fix cannot follow the opacity property in dde-appearance
  * when data is text, the height of the itemwidget is dynamic
  * fix when zoom is not 1x, the icon is blurry

 -- chenhongtao <chenhongtao@deepin.org>  Thu, 03 Aug 2023 17:53:05 +0800

dde-clipboard (1:6.0.4) unstable; urgency=medium

  * chore: Desktop文件中OnlyShowIn使用错误

 -- dengbo <dengbo@uniontech.com>  Fri, 21 Apr 2023 14:31:05 +0800

dde-clipboard (1:6.0.3) unstable; urgency=medium

  * ensure compliant with REUSE spec.

 -- Wang Zichong <wangzichong@deepin.org>  Mon, 03 Apr 2023 16:44:00 +0800

dde-clipboard (1:6.0.2) unstable; urgency=medium

  [ TagBuilder ]
  * chore: Retrigger build(Influence: 无)
  * fix: 修复注销时反复尝试启动的问题(Task: 203055)(Influence: 理论上加快注销的时间)
  * chore: V23接口改造适配(Task: 207483)(Influence: 无)

 -- zhaoyingzhen <zhaoyingzhen@uniontech.com>  Tue, 13 Dec 2022 17:38:08 +0800

dde-clipboard (6.0.1) unstable; urgency=medium

  [ Deepin Packages Builder ]
  * fix: fix time format issue in chagelog(Influence: 无)
  * fix: 修复v23wayland下剪切板无数据的问题。(Bug: 147089)(Influence: 剪切板全量功能，尤其是wayland下剪切板功能。)

 -- baodi <baodi@uniontech.com>  Wed, 19 Oct 2022 13:04:00 +0800

dde-clipboard (6.0.0) unstable; urgency=low

  * release 6.0.0

 --  <fanpengcheng@uniontech.com>  Tue, 14 Jun 2022 16:56:13 +0800

=== debian/control ===
Source: dde-clipboard
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends: debhelper (>= 8.0.0),
 pkg-config,
 cmake,
 libdtkwidget-dev,
 libdtkcore-dev,
 qttools5-dev-tools,
 libdtkcore5-bin,
 qtbase5-private-dev,
 libgio-qt-dev,
 libdframeworkdbus-dev,
 libgtest-dev,
 extra-cmake-modules,
 libdwayland-dev,
 libkf5wayland-dev,
 systemd
Standards-Version: 3.9.5
Homepage: https://github.com/linuxdeepin/dde-clipboard

Package: dde-clipboard
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 dde-daemon (>=5.12.0.31),
 startdde (>=5.6.0.34),
 dde-api (>=2.92.1),
 dde-session (>=1.1.5)
Description: deepin desktop-environment - clipboard module
 Clipboard module of deepin desktop-environment

## dde-clipboard 6.0.13

=== debian/changelog ===
dde-clipboard (1:6.0.13) unstable; urgency=medium

  * fix: clipboard background transparent

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 11 Sep 2024 15:30:56 +0800

dde-clipboard (1:6.0.12) unstable; urgency=medium

  * fix: window removes its own display animation (#170)(Issue: 9728)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 29 Aug 2024 10:53:46 +0800

## dde-clipboard 6.1.8

=== debian/changelog ===
dde-clipboard (1:6.1.8) unstable; urgency=medium

  * fix: update dde-clipboard-daemon service dependencies

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 17:43:38 +0800

dde-clipboard (1:6.1.7) unstable; urgency=medium

  * chore: remove startdde dependency

 -- fuleyi <fuleyi@uniontech.com>  Wed, 02 Apr 2025 11:26:28 +0800

dde-clipboard (1:6.1.6) unstable; urgency=medium

  * fix: double click can't select item

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 13 Feb 2025 20:36:47 +0800

dde-clipboard (1:6.1.5) unstable; urgency=medium

  * feat: add restart when failed
  * feat: Add files generated by qdbusXML2cpp and DCONG2cpp

 -- YeShanShan <yeshanshan@deepin.org>  Tue, 14 Jan 2025 20:23:31 +0800

dde-clipboard (1:6.1.4) unstable; urgency=medium

  * fix: clipboard does not show in primary screen #183
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 09 Jan 2025 16:13:12 +0800

dde-clipboard (1:6.1.3) unstable; urgency=medium

  * chore: provide dci icon for the dcc of V25

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 02 Jan 2025 19:01:26 +0800

dde-clipboard (1:6.1.2) unstable; urgency=medium

  * release 1:6.1.2

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 11 Dec 2024 18:31:34 +0800

dde-clipboard (1:6.1.1) unstable; urgency=medium

  * chore: refactor unreasonable places (#177)(Task: 367947)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 20 Nov 2024 11:17:06 +0800

dde-clipboard (1:6.1.0) unstable; urgency=medium

  * refactor: port to Qt6, new Wayland implementation

 -- Wu Haotian <wuhaotian@uniontech.com>  Wed, 06 Nov 2024 14:46:56 +0800

dde-clipboard (1:6.0.14) unstable; urgency=medium

  * chore: add the dde-clipboard plugin 

 -- Wang Fei <wangfei@deepin.org>  Wed, 11 Sep 2024 15:30:56 +0800

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

export QT_SELECT = qt6

%:
	dh $@ --parallel

## dde-clipboard 6.1.9

=== debian/changelog ===
dde-clipboard (1:6.1.9) unstable; urgency=medium

  * chore: remove unused Spanish translation file

 -- YeShanShan <yeshanshan@uniontech.com>  Mon, 23 Jun 2025 17:16:01 +0800

## dde-clipboard 6.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
+set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall")
@@ -29,38 +30,26 @@
 
 if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
-
-    # generate qm
-    execute_process(COMMAND bash "translate_generation.sh"
-                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 endif ()
+
+set(QT_VERSION_MAJOR 6)
+set(DTK_VERSION_MAJOR 6)
 
 # Find the library
 find_package(PkgConfig REQUIRED)
-find_package(Dtk COMPONENTS Widget Core REQUIRED)
-find_package(Qt5 COMPONENTS Core Gui Widgets DBus Test Concurrent REQUIRED)
+find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget Core Tools REQUIRED)
+find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Gui Widgets DBus WaylandClient Test Concurrent LinguistTools REQUIRED)
+find_package(DDEShell REQUIRED)
+find_package(DdeTrayLoader REQUIRED)
 
 find_package(ECM REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
-find_package(DWayland REQUIRED)
-
-pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-qt)
+
+pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-qt6)
 
 if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
     pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
 endif()
-
-find_package(DtkTools REQUIRED)
-function(generation_dbus_adaptor xml class_name class_file option)
-    execute_process(COMMAND qdbusxml2cpp ${option} -a ${class_file} -c ${class_name} ${xml}
-    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
-endfunction(generation_dbus_adaptor)
-
-set(DBUS_INTERFACE ${PROJECT_SOURCE_DIR}/dbus/interface)
-function(generation_dbus_interface xml class_name class_file)
-    execute_process(COMMAND ${DTK_XML2CPP} -c ${class_name} -p ${class_file} ${xml}
-        WORKING_DIRECTORY ${DBUS_INTERFACE})
-endfunction(generation_dbus_interface)
 
 include_directories(
     dde-clipboard
@@ -70,30 +59,11 @@
 )
 
 #----------------------------dde-clipboard------------------------------
-generation_dbus_adaptor(
-    ${CMAKE_SOURCE_DIR}/dde-clipboard/org.deepin.dde.Clipboard1.xml
-    ClipboardAdaptor
-    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor
-    -N
-)
-
-generation_dbus_interface(
-    ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.Display1.Monitor.xml
-    Monitor
-    ${DBUS_INTERFACE}/monitor_interface
-)
-
-generation_dbus_interface(
-    ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.Display1.xml
-    Display1
-    ${DBUS_INTERFACE}/display_interface
-)
-
-generation_dbus_interface(
-    ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.daemon.Dock1.xml
-    Dock1
-    ${DBUS_INTERFACE}/dock_interface
-)
+
+qt_add_dbus_adaptor(DBUS_INTERFACES ${CMAKE_SOURCE_DIR}/dde-clipboard/org.deepin.dde.Clipboard1.xml mainwindow.h MainWindow)
+dtk_add_dbus_interface(DBUS_INTERFACES ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.Display1.Monitor.xml display1monitorinterface)
+dtk_add_dbus_interface(DBUS_INTERFACES ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.Display1.xml display1interface)
+qt_add_dbus_interface(DBUS_INTERFACES ${CMAKE_SOURCE_DIR}/dbus/org.deepin.dde.daemon.Dock1.xml dock1interface)
 
 include_directories(
     ${PROJECT_SOURCE_DIR}/dbus/interface
@@ -102,12 +72,6 @@
 )
 
 aux_source_directory(dbus/types DBUS_TYPES)
-aux_source_directory(dbus/interface DBUS_INTERFACES)
-
-set(Clipboard_DBUS_SCRS
-    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor.h
-    ${CMAKE_CURRENT_BINARY_DIR}/clipboard_adaptor.cpp
-)
 
 file(GLOB_RECURSE Clipboard_SCRS
     "dde-clipboard/*.h"
@@ -124,14 +88,37 @@
 )
 
 target_link_libraries(${BIN_NAME} PRIVATE
-    Dtk::Widget
-    Dtk::Core
+    Dtk${DTK_VERSION_MAJOR}::Widget
+    Dtk${DTK_VERSION_MAJOR}::Core
     PkgConfig::GIO
-    Qt5::Core
-    Qt5::Widgets
-    Qt5::GuiPrivate
-    Qt5::Gui
-    Qt5::DBus
+    Qt${QT_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::Widgets
+    Qt${QT_VERSION_MAJOR}::GuiPrivate
+    Qt${QT_VERSION_MAJOR}::Gui
+    Qt${QT_VERSION_MAJOR}::DBus
+    Dde::Shell
+)
+
+# can use qt_standard_project_setup(I18N_TRANSLATED_LANGUAGES xx xx) from Qt6.7
+set(TRANSLATION_LANGUAGES
+    af am_ET ar ast az bg bn bo ca cs da de el_GR el en_AU en_GB eo es_419 es
+    et fa fi fr gl_ES he hi_IN hi hr hu hy id it ja kab ko ku_IQ ku ky@Arab
+    lt lv ml mn ms nb ne nl pa pl pt_BR pt ro ru si sk sl sq sr sv sw ta tr
+    ug uk vi zh_CN zh_HK zh_TW
+)
+
+set(TRANSLATION_FILES "")
+list(APPEND TRANSLATION_FILES "${PROJECT_SOURCE_DIR}/translations/dde-clipboard.ts")
+
+foreach(LANG ${TRANSLATION_LANGUAGES})
+    list(APPEND TRANSLATION_FILES "${PROJECT_SOURCE_DIR}/translations/dde-clipboard_${LANG}.ts")
+endforeach()
+
+# can generate ts and qm file
+qt_add_translations(${BIN_NAME}
+    TS_FILES ${TRANSLATION_FILES}
+    SOURCES ${Clipboard_SCRS}
+    QM_FILES_OUTPUT_VARIABLE TRANSLATED_FILES
 )
 
 macro(install_symlink filepath wantsdir)
@@ -141,8 +128,7 @@
 endmacro(install_symlink)
 
 ## qm files
-file(GLOB QM_FILES "translations/*.qm")
-install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${BIN_NAME}/translations)
+install(FILES ${TRANSLATED_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${BIN_NAME}/translations)
 
 configure_file(
     misc/dde-clipboard.service.in
@@ -170,21 +156,24 @@
 set(BIN_NAME dde-clipboard-daemon)
 
 file(GLOB_RECURSE dde-clipboard-daemon_SCRS
-        "dde-clipboard-daemon/*.h"
-        "dde-clipboard-daemon/*.cpp"
+    "dde-clipboard-daemon/*.h"
+    "dde-clipboard-daemon/*.cpp"
 )
 
 add_executable(${BIN_NAME}
     ${dde-clipboard-daemon_SCRS}
 )
 
+qt_generate_wayland_protocol_client_sources(${BIN_NAME} FILES
+    ${CMAKE_CURRENT_SOURCE_DIR}/dde-clipboard-daemon/protocol/wlr-data-control-unstable-v1.xml)
+
 target_link_libraries(${BIN_NAME} PRIVATE
-  Qt5::Gui
-  Qt5::DBus
-  Qt5::Widgets
-  Dtk::Core
-  Qt5::Concurrent
-  DWaylandClient
+    Qt${QT_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::DBus
+    Qt${QT_VERSION_MAJOR}::Concurrent
+    Qt${QT_VERSION_MAJOR}::WaylandClient
+    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
+    Dtk${DTK_VERSION_MAJOR}::Core
 )
 
 install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
@@ -235,14 +224,48 @@
 target_compile_options(${UT_BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
 
 target_link_libraries(${UT_BIN_NAME} PRIVATE
-    Dtk::Widget
+    Dtk${DTK_VERSION_MAJOR}::Widget
     PkgConfig::GIO
-    Qt5::Core
-    Qt5::Widgets
-    Qt5::DBus
-    Qt5::Test
-    Qt5::GuiPrivate
+    Qt${QT_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::Widgets
+    Qt${QT_VERSION_MAJOR}::DBus
+    Qt${QT_VERSION_MAJOR}::Test
+    Qt${QT_VERSION_MAJOR}::GuiPrivate
+    Dde::Shell
     -lpthread
     -lgcov
     -lgtest
 )
+
+#--------------------------dock-plugin---------------------------
+set(PLUGIN_NAME dock-clipboard-plugin)
+
+file(GLOB_RECURSE SRCS
+    "dock-clipboard-plugin/*.h"
+    "dock-clipboard-plugin/*.cpp"
+    "dock-clipboard-plugin/widget/*.h"
+    "dock-clipboard-plugin/widget/*.cpp"
+)
+
+add_definitions("${QT_DEFINITIONS} -DQT_PLUGIN")
+add_library(${PLUGIN_NAME} SHARED ${SRCS} dock-clipboard-plugin/resources/clipboard.qrc)
+target_include_directories(${PLUGIN_NAME} PUBLIC
+    Dtk${DTK_VERSION_MAJOR}::Widget
+    Qt${QT_VERSION_MAJOR}::Core
+    ${OBJECT_BINARY_DIR}
+    ${DDE_DOCK_INCLUDE_DIR}
+    dock-clipboard-plugin/widget/
+)
+target_link_libraries(${PLUGIN_NAME} PRIVATE
+    Dtk${DTK_VERSION_MAJOR}::Widget
+    Dtk${DTK_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::DBus
+    Qt${QT_VERSION_MAJOR}::Widgets
+)
+
+# 设置执行 make install 时哪个目标应该被 install 到哪个位置
+install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins)
+# for dcc-v23
+install(FILES "dock-clipboard-plugin/resources/clipboard.svg" DESTINATION share/dde-dock/icons/dcc-setting)
+# for dcc-v25
+install(FILES "dock-clipboard-plugin/resources/dcc-clipboard.dci" DESTINATION share/dde-dock/icons/dcc-setting)

=== debian/changelog ===
dde-clipboard (1:6.1.10) unstable; urgency=medium

  * fix: enhance build security hardening options

 -- WuJiangYu <wujiangyu@uniontech.com>  Thu, 03 Jul 2025 19:57:07 +0800

=== debian/control ===
Source: dde-clipboard
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends: debhelper (>= 8.0.0),
 pkg-config,
 cmake,
 libdtk6widget-dev,
 libdtk6core-dev,
 libdtk6core-bin,
 qtchooser,
 qmake6,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-declarative-dev,
 libdtk6gui-dev,
 libdtk6core-bin,
 libdtk6core-dev,
 qt6-l10n-tools,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-wayland-dev,
 qt6-wayland-private-dev,
 qt6-wayland-dev-tools,
 libdde-shell-dev,
 libgio-qt-dev,
 libgtest-dev,
 extra-cmake-modules,
 systemd,
 dde-tray-loader-dev (>= 0.0.11)
Standards-Version: 3.9.5
Homepage: https://github.com/linuxdeepin/dde-clipboard

Package: dde-clipboard
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 dde-daemon (>=6.1.26),
 dde-api (>=2.92.1),
 dde-session (>=1.1.5)
Description: deepin desktop-environment - clipboard module
 Clipboard module of deepin desktop-environment

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

export QT_SELECT = qt6
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall
export DEB_CXXFLAGS_MAINT_APPEND = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E

%:
	dh $@ --parallel

## dde-clipboard 6.1.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,8 @@
 set(BIN_NAME dde-clipboard)
 
 project(${BIN_NAME})
+
+option(ENABLE_COV "Enable code coverage" OFF)
 
 #set(CMAKE_VERBOSE_MAKEFILE ON)
 set(CMAKE_CXX_STANDARD 17)
@@ -39,6 +41,9 @@
 find_package(PkgConfig REQUIRED)
 find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget Core Tools REQUIRED)
 find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Gui Widgets DBus WaylandClient Test Concurrent LinguistTools REQUIRED)
+if(Qt${QT_VERSION_MAJOR}_VERSION VERSION_GREATER_EQUAL 6.10)
+  find_package(Qt${QT_VERSION_MAJOR} COMPONENTS GuiPrivate WaylandClientPrivate REQUIRED)
+endif()
 find_package(DDEShell REQUIRED)
 find_package(DdeTrayLoader REQUIRED)
 
@@ -103,7 +108,7 @@
 set(TRANSLATION_LANGUAGES
     af am_ET ar ast az bg bn bo ca cs da de el_GR el en_AU en_GB eo es_419 es
     et fa fi fr gl_ES he hi_IN hi hr hu hy id it ja kab ko ku_IQ ku ky@Arab
-    lt lv ml mn ms nb ne nl pa pl pt_BR pt ro ru si sk sl sq sr sv sw ta tr
+    lo lt lv ml mn ms nb ne nl pa pl pt_BR pt ro ru si sk sl sq sr sv sw ta tr
     ug uk vi zh_CN zh_HK zh_TW
 )
 
@@ -221,7 +226,9 @@
     ${DBUS_TYPES}
 )
 # 用于测试覆盖率的编译条件
-target_compile_options(${UT_BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
+if (ENABLE_COV)
+    target_compile_options(${UT_BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
+endif()
 
 target_link_libraries(${UT_BIN_NAME} PRIVATE
     Dtk${DTK_VERSION_MAJOR}::Widget

=== debian/changelog ===
dde-clipboard (1:6.1.14) unstable; urgency=medium

  * fix: Fix the issue of multiple records being created when copying text repeatedly
  * fix: Fix the issue of weekdays not being translated 
  * fix: Fix the clipboard not moving with the dock

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 23 Oct 2025 16:14:45 +0800

dde-clipboard (1:6.1.13) unstable; urgency=medium

  * chore: add `lo` to TRANSLATION_LANGUAGES list

 -- YeShanShan <yeshanshan@uniontech.com>  Fri, 26 Sep 2025 16:07:50 +0800

dde-clipboard (1:6.1.12) unstable; urgency=medium

  * fix: correct scaling position calculation 
  * fix: adjust window positioning for right dock 
  * i18n: Translate dde-clipboard.ts in lo(#206)
  * i18n: Translate dde-clipboard.ts in de_DE (#204)

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 18 Sep 2025 19:47:54 +0800

dde-clipboard (1:6.1.11) unstable; urgency=medium

  * Updates for project Deepin Desktop Environment (#200)
  * i18n: Updates for project Deepin Desktop Environment (#199)
  * chore: update configurations for REUSE and tx-cli
  * chore: update translations from Transifex
  * chore: Optimize packaging (#198)
  * fix: make coverage compilation conditional

 -- Kun Zhang <zhangkun2@uniontech.com>  Thu, 03 Jul 2025 19:57:07 +0800

=== debian/control ===
Source: dde-clipboard
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dde-tray-loader-dev (>= 0.0.11),
 extra-cmake-modules,
 libdde-shell-dev,
 libdtk6core-bin,
 libdtk6core-dev,
 libdtk6gui-dev,
 libdtk6widget-dev,
 libgio-qt-dev,
 libgtest-dev,
 pkg-config,
 qmake6,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-declarative-dev,
 qt6-l10n-tools,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-wayland-dev,
 qt6-wayland-dev-tools,
 qt6-wayland-private-dev,
 qtchooser,
 systemd,
Standards-Version: 4.6.2
Homepage: https://github.com/linuxdeepin/dde-clipboard

Package: dde-clipboard
Architecture: any
Depends:
 dde-api (>=2.92.1),
 dde-daemon (>=6.1.26),
 dde-session (>=1.1.5),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 dde-shell (<< 1.99.3),
Replaces:
 dde-shell (<< 1.99.3),
Description: deepin desktop-environment - clipboard module
 Clipboard module of deepin desktop-environment

=== debian/rules ===
--- 
+++ 
@@ -8,4 +8,4 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E
 
 %:
-	dh $@ --parallel
+	dh $@

## dde-clipboard 6.1.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -88,6 +88,7 @@
     ${Clipboard_SCRS}
     ${Clipboard_DBUS_SCRS}
     dde-clipboard/main.cpp
+    dde-clipboard/resources.qrc
     ${DBUS_INTERFACES}
     ${DBUS_TYPES}
 )

=== debian/changelog ===
dde-clipboard (1:6.1.16) unstable; urgency=medium

  * fix: Fix the rounded corner jagged edges issue
  * i18n: Updates for project Deepin Desktop Environment (#228)
  * fix: Update translate
  * fix: Fix some text fonts not changing
  * i18n: Updates for project Deepin Desktop Environment (#224)

 -- caixiangrong <caixiangrong@uniontech.com>  Thu, 06 Nov 2025 15:55:19 +0800

dde-clipboard (1:6.1.15) unstable; urgency=medium

  * fix: Fix the issue of excessively high text height
  * fix: enable vertical scrollbar in clipboard list view
  * fix: Fix the abnormal display of the copy icon
  * fix: Add no-data icon and prompt

 -- Robertkill <lvpeilong@uniontech.com>  Thu, 30 Oct 2025 19:13:13 +0800
